%option noyywrap
%option C++
%option yylineno
%option yyclass="MyLexer"
%{
#define TRUE 1
#define FALSE 0
#include "defs.h"
#include "ValHolder.h"
#include "MyLexer.h"
#include <stdio.h>
#include <ctype.h>
%}
wspace [ \t\n\r\v]
pozn "/""*"(([^/]|\n|([^*]{1}"/"))*)"*""/"
unterm_pozn "/""*"(([^/]|\n|([^*]{1}"/"))*)
rad_pozn "//".*
letter [a-zA-Z]
digit [0-9]
znak_ident ({letter}|{digit}|_)
identint ((_{znak_ident}+)|({letter}({znak_ident}*)))
identstr {identint}"$"
identreal {identint}"#"
prik_let (L|l)(E|e)(T|t)
prik_read (R|r)(E|e)(A|a)(D|d)
prik_print (P|p)(R|r)(I|i)(N|n)(T|t)
op_div (D|d)(I|i)(V|v)
op_mod (M|m)(O|o)(D|d)
op_plus "+"
op_minus "-"
op_krat "*"
op_deleno "/"
strednik ;
carka ,
rovnitko =
lzavorka \(
pzavorka \)
hex_digit [0-9a-fA-F]
okt_digit [0-7]
hex_cislo 0(X|x){hex_digit}+
bad_hex_cislo 0(X|x){hex_digit}*[g-zG-Z]+{hex_digit}*
okt_cislo 0{okt_digit}+
bad_okt_cislo 0{okt_digit}*[89]+{okt_digit}*
cislo {digit}+
bad_cislo {digit}+[A-Za-z]*{digit}*
mantisa ({cislo}+\.)|(\.{cislo}+)|({cislo}+\.{cislo})
exponent [+-]?{cislo}
real_cislo ({mantisa}([eE]{exponent})?)|({cislo}[eE]{exponent})
bad_real_cislo ({mantisa}[eE])|({cislo}[eE])
string \"((\\\")*)(([^"]|\n|([^\\]((\\\\)*)(\\\")))*)\"
unterm_string \"((\\\")*)([^"]|\n|([^\\]((\\\\)*)(\\\")))*
zbytek .
%%
{wspace}	;
{pozn}		;
{unterm_pozn}	{int i=0;
		 for(int j=0;yytext[j]!=0;j++){
		   if(yytext[j]=='\n'){
		     i++;
		   }
		 }
		 cout<< filename << (yylineno-i);
		 cout<<": unterminated comment"<<endl;}
{rad_pozn}	;
{string}	{char* ret = new char[yyleng];
                 escape(yytext,ret);
		 hodnota.setVal(ret);
 		 hodnota.setTyp(STYP);
		 return STRING;}
{unterm_string}	{int i=0;
		 for(int j=0;yytext[j]!=0;j++){
		   if(yytext[j]=='\n'){
		     i++;
		   }
		 }
		 cout<<yylineno<< filename ;
		 cout<<": unterminated string or character constant"<<endl;
		 cout<< filename <<(yylineno-i);
		 cout<<": posible real start of unterminated constant"<<endl;
 		 hodnota.setTyp(ETYP);}
{prik_let}	return LET;
{prik_read}	return READ;
{prik_print}	return PRINT;
{op_krat}	return KRAT;
{op_deleno}	return DELENO;
{op_minus}	return MINUS;
{op_plus}	return PLUS;
{op_div}	return DIV;
{op_mod}	return MOD;
{identint} 	{
		 char *n=new char[strlen(yytext)+1];	
		 mstrcpy(n,yytext);
		 hodnota.setName(n);
		 hodnota.setTyp(ITYP);
		 return IDINT;}
{identstr} 	{
		 char *n=new char[strlen(yytext)+1];	
		 mstrcpy(n,yytext);
		 hodnota.setName(n);
 		 hodnota.setTyp(STYP);
		 return IDSTR;}
{identreal} 	{
		 char *n=new char[strlen(yytext)+1];	
		 mstrcpy(n,yytext);
		 hodnota.setName(n);
 		 hodnota.setTyp(RTYP);
		 return IDREAL;}
{strednik}	return STREDNIK;
{lzavorka}	return LZAVORKA;
{pzavorka}	return PZAVORKA;
{carka}		return CARKA;
{rovnitko}	return ROVNITKO;
{hex_cislo}	{int cislo;
		 sscanf(yytext,"%x",&cislo);
		 hodnota.setVal(cislo);
 		 hodnota.setTyp(ITYP);
		 return CISLO;}
{bad_hex_cislo}	{cout<< filename <<yylineno;
	cout<<": numeric constant contains digits beyond the radix"<<endl;
		 return CISLO;}
{okt_cislo}	{int cislo;
		 sscanf(yytext,"%o",&cislo);
		 hodnota.setVal(cislo);
 		 hodnota.setTyp(ITYP);
		 return CISLO;}
{bad_okt_cislo}	{cout<< filename <<yylineno;
	cout<<": numeric constant contains digits beyond the radix"<<endl;
		 return CISLO;}
{real_cislo}	{double cislo;
		 sscanf(yytext,"%lf",&cislo);
		 hodnota.setVal(cislo);
 		 hodnota.setTyp(RTYP);
		 return REAL;}
{cislo}		{
		 int cislo;
		 sscanf(yytext,"%d",&cislo);
		 hodnota.setVal(cislo);
 		 hodnota.setTyp(ITYP);
		 return CISLO;}
{bad_cislo}	{cout<< filename <<yylineno;
		 cout<<": nondigits in number and not hexadecimal"<<endl;
		 return CISLO;}
{bad_real_cislo}	{cout<< filename <<yylineno;
	cout<<": floating constant exponent has no digits"<<endl;
		 return REAL;}
<<EOF>>		{return KONEC;}
{zbytek}	{cout <<  filename <<yylineno << ": ";
		 cout << "unexpected character '" << yytext; 
		 cout << "'" << endl;
		}
%%
char* MyLexer::mstrcpy(char* cil,char* zdroj){
  int i=0;
  while(zdroj[i]!='\0'){
    cil[i]=toupper(zdroj[i]);
    i++;
  }
  cil[i]='\0';
  return cil;
}
void MyLexer::escape(char *vstup,char *vystup){
  int i,j;
  i=0;
  j=0;
  
  char ccislo[5];
  while(vstup[i]!='\0'){
    if(vstup[i]=='\"'){
      i++;
    }
    if(vstup[i]=='\\'){
      i++;
      if(vstup[i]==0){
        break;
      }
      switch(vstup[i]){
        case '\\':vystup[j]='\\';
                j++;
                i++;
		break;
        case 'n':vystup[j]='\n';
                j++;
                i++;
		break;
        case 'r':vystup[j]='\x0D';
                j++;
                i++;
		break;
        case 'f':vystup[j]='\x0C';
                j++;
                i++;
		break;
        case 't':vystup[j]='\x09';
                j++;
                i++;
		break;
        case 'b':vystup[j]='\x08';
                j++;
                i++;
		break;
        case 'v':vystup[j]='\v';
                j++;
                i++;
		break;
        case '?':vystup[j]='\?';
                j++;
                i++;
		break;
        case 'a':vystup[j]='\x07';
                j++;
                i++;
		break;
        case '\'':vystup[j]='\'';
                j++;
                i++;
		break;
        case '\"':vystup[j]='\"';
                j++;
                i++;
		break;
        case '0':vystup[j]='\x00';
                j++;
                i++;
		break;
        case 'x':
        case 'X':i++;
		if(vstup[i]=='\0'){
                  continue;
                }
                if(isxdigit(vstup[i])){
                  ccislo[0]='0';
		  ccislo[1]='x';
		  ccislo[2]=vstup[i];
                  if(isxdigit(vstup[i+1])){
                    ccislo[3]=vstup[i+1];
		    ccislo[4]='\0';
		    i+=2;
		  }
		  else{
		    ccislo[3]='\0';
		    i++;
		  }
		  sscanf(ccislo,"%x",&vystup[j]);
		  j++;
                }
                else {
        	  cout<<filename<<yylineno<<": "<<"warning: \\x used with no "
			"following hex digits"<<endl;
		  i++;         
                }
		break;
        default: cout<< filename <<yylineno;
		 cout<<": "<<"warning: unknown escape sequence \\"<<
			vstup[i]<<endl;
		vystup[j]=vstup[i];
		j++;
		i++;         
                break;
      }
    }
    else{
      vystup[j]=vstup[i];
      i++;
      j++;
    }
  }
  vystup[j]='\0';
}
