/*
 * Autor: Martin Kot
 * Nazev: Prekladac
 * Studijni cislo: KOT119
 */

#define TRUE 1
#define FALSE 0
#include <FlexLexer.h>
#include "defs.h"
#include "Symbols.h"
#include "ValHolder.h"
#include "VarTable.h"
#include "MyLexer.h"
#include "Syntakt.h"

Syntakt::Syntakt(){
  filename = "";
  lexik=NULL;
  symCount=0;
  lastSym=0;
}
Syntakt::Syntakt(MyLexer *lex){
  filename = "";
  lexik=lex;
  sym=(Symbol)(lexik->yylex());
  symVal=lexik->getHod();
  symCount=1;
  lastSym=0;
}
Syntakt::Syntakt(MyLexer *lex,char *fname){
  int i =strlen(fname);
  filename = new char[i+2];
  strcpy(filename,fname);
  filename[i] = ':';
  filename[i+1] = '\0';
  
  lexik=lex;
  sym=(Symbol)(lexik->yylex());
  symVal=lexik->getHod();
  symCount=1;
  lastSym=0;
}


void Syntakt::error(){
  if(lastSym!=symCount){
    cout << filename << lexik->lineno() <<": parse error before '";
    cout << lexik->YYText() <<"'"<<endl;
    lastSym=symCount;
  }
}
void Syntakt::expect(int s,Symbols mnozina){
  if(s==sym){
    sym=(Symbol)(lexik->yylex());	
    symVal=lexik->getHod();
    symCount++;
  }
  else{
    if(lastSym!=symCount){
      cout << filename << lexik->lineno() <<": parse error before '";
      cout << lexik->YYText() <<"'"<<endl;
      cout << filename << lexik->lineno() <<": expected '";
      cout<< SYMBOLS_NAMES[Symbols::poradi(s)] << "'" <<endl;
      lastSym=symCount;
    }
    while(!mnozina.obsahuje(sym)){
      sym=(Symbol)(lexik->yylex());	
      symVal=lexik->getHod();
      symCount++;
    }
  }
}
void Syntakt::check(Symbols ocekavane, Symbols zachytne){
  if(!ocekavane.obsahuje(sym)){
    error();
    Symbols mozne=ocekavane+zachytne;
    while(!mozne.obsahuje(sym)){
      sym=(Symbol)(lexik->yylex());	
      symVal=lexik->getHod();
      symCount++;
      lastSym++;
    }
  }
} 
//A->S eof
void Syntakt::a(){
  s(KONEC);
  expect(KONEC,KONEC);
}
 
//S->PS1|e
void Syntakt::s(Symbols zachytne){
  check(Symbols(STREDNIK|LET|READ|PRINT|KONEC),zachytne);
  if(sym==LET || sym==READ || sym==PRINT){
    p(zachytne+Symbols(STREDNIK|LET|READ|PRINT|KONEC));
    s1(zachytne+Symbols(KONEC));
  }
}
//S1->PS1|e
void Syntakt::s1(Symbols zachytne){
  check(Symbols(STREDNIK|KONEC),zachytne);
  if(sym==STREDNIK){
    expect(STREDNIK,zachytne);
    p(zachytne+Symbols(STREDNIK|LET|READ|PRINT|KONEC));
    s1(zachytne+Symbols(KONEC));
  }
}
//p->let id=E|read id O|print EQ
void Syntakt::p(Symbols zachytne){
  check(Symbols(STREDNIK|KONEC|LET|READ|PRINT),zachytne);
  if(sym==LET){
    ValHolder prom;
    ValHolder aktHodnota;
    expect(LET,zachytne);
    prom = id(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|PZAVORKA));
    expect(ROVNITKO,zachytne);
    aktHodnota = e(zachytne+Symbols(CARKA|STREDNIK|PZAVORKA));
    if(prom.getTyp()==RTYP && aktHodnota.getTyp()==ITYP){
      aktHodnota.setTyp(RTYP);
      aktHodnota.setVal((double)(aktHodnota.getVal().intValue));
    }
    if(aktHodnota.getTyp()!=ETYP){
      if(prom.getTyp() == aktHodnota.getTyp()){
        table.setVal(prom.getName(),aktHodnota);
        table.setDef(prom.getName());
      }
      else {
        cout << filename << lexik->lineno() << ": unable to initialize '";
        cout << TypesNames[prom.getTyp()]<<"' variable '";
        cout << prom.getName() << "' with '";
        cout << TypesNames[aktHodnota.getTyp()]<<"' value"<<endl;
      }
    }
    else {
      table.setVal(prom.getName(),aktHodnota);
      table.setUndef(prom.getName());
    }
  }
  else if(sym==READ){
    expect(READ,zachytne);
    ValHolder prom;
    ValHolder aktHodnota;
    prom = id(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|PZAVORKA));
    aktHodnota.setTyp(prom.getTyp());
    cin>>aktHodnota;
    table.setDef(prom.getName());
    table.setVal(prom.getName(),aktHodnota);
    o(zachytne+Symbols(STREDNIK|KONEC));
  }
  else if(sym==PRINT){
    ValHolder aktHodnota;
    expect(PRINT,zachytne);
    aktHodnota = e(zachytne+Symbols(CARKA|STREDNIK|PZAVORKA));
    cout << aktHodnota;
    q(zachytne+Symbols(STREDNIK|KONEC));
    cout << endl;
  }
}
//O->,ID O|e
void Syntakt::o(Symbols zachytne){
  check(Symbols(CARKA|STREDNIK|KONEC),zachytne);
  if(sym==CARKA){
    expect(CARKA,zachytne);
    ValHolder prom;
    ValHolder aktHodnota;
    prom = id(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|PZAVORKA));
    aktHodnota.setTyp(prom.getTyp());
    cin>>aktHodnota;
    table.setDef(prom.getName());
    table.setVal(prom.getName(),aktHodnota);
    o(zachytne+Symbols(STREDNIK|KONEC));
  }
}
//Q->,EQ|e
void Syntakt::q(Symbols zachytne){
  check(Symbols(CARKA|STREDNIK|KONEC),zachytne);
  ValHolder aktHodnota;
  if(sym==CARKA){
    expect(CARKA,zachytne);
    aktHodnota = e(zachytne+Symbols(CARKA|STREDNIK|PZAVORKA));
    cout << aktHodnota;
    q(zachytne+Symbols(STREDNIK|KONEC));
  }
}
//E->T E1
ValHolder Syntakt::e(Symbols zachytne){
  check(Symbols(LZAVORKA|PLUS|MINUS|CISLO|STRING|REAL|IDINT|IDREAL|IDSTR),
		zachytne);
  ValHolder aktHodnota = symVal; 
  aktHodnota = t(zachytne+Symbols(PLUS|MINUS|CARKA|STREDNIK|PZAVORKA));
  aktHodnota = e1(zachytne+Symbols(CARKA|STREDNIK|KONEC|PZAVORKA),aktHodnota);
  return aktHodnota;
}
//E1->+T E1 | -T E1 | e
ValHolder Syntakt::e1(Symbols zachytne, ValHolder leftVal){
  check(Symbols(PLUS|MINUS|PZAVORKA|STREDNIK|CARKA|KONEC)
		,zachytne);
  ValHolder aktHodnota = leftVal; 
  int aHT;
  if(sym==PLUS){
    expect(PLUS,zachytne);
    aktHodnota = t(zachytne+Symbols(PLUS|MINUS|CARKA|STREDNIK|PZAVORKA|KONEC));
    aHT=aktHodnota.getTyp();
    aktHodnota = leftVal + aktHodnota;
    if(aHT != ETYP && leftVal.getTyp() != ETYP && aktHodnota.getTyp()==ETYP){
      cout << filename << lexik->lineno() << ": unable to add '";
      cout << TypesNames[aHT]<<"' value to '";
      cout << TypesNames[leftVal.getTyp()]<<"' value"<<endl;
    }
    aktHodnota = e1(zachytne
	+Symbols(CARKA|STREDNIK|KONEC|PZAVORKA), aktHodnota);
  }
  else if(sym==MINUS){
    expect(MINUS,zachytne);
    aktHodnota = t(zachytne
	+Symbols(PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA));
    aHT=aktHodnota.getTyp();
    aktHodnota = leftVal - aktHodnota;
    if(aHT != ETYP && leftVal.getTyp() != ETYP && aktHodnota.getTyp()==ETYP){
      cout << filename << lexik->lineno() << ": unable to subtract '";
      cout << TypesNames[aHT]<<"' value from '";
      cout << TypesNames[leftVal.getTyp()]<<"' value"<<endl;
    }
    aktHodnota = e1(zachytne
	+Symbols(CARKA|STREDNIK|PZAVORKA), aktHodnota);
  }
  return aktHodnota;
}
//T->F T1
ValHolder Syntakt::t(Symbols zachytne){
  check(Symbols(LZAVORKA|PLUS|MINUS|CISLO|STRING|REAL|IDINT|IDREAL|IDSTR),
		zachytne);
  ValHolder aktHodnota = symVal; 
  aktHodnota = f(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA));
  aktHodnota = t1(zachytne
	+Symbols(PLUS|MINUS|CARKA|STREDNIK|PZAVORKA|KONEC),aktHodnota);
  return aktHodnota;
}
//T1-> /F T1 | *F T1 | div F T1 | mod F T1 | e
ValHolder Syntakt::t1(Symbols zachytne, ValHolder leftVal){
  check(Symbols(PLUS|MINUS|KRAT|DELENO|DIV|MOD|CARKA|STREDNIK|PZAVORKA|KONEC)
		,zachytne);
  ValHolder aktHodnota = leftVal; 
  int aHT;
  if(sym==DELENO){
    expect(DELENO,zachytne);
    aktHodnota = f(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA));
    aHT=aktHodnota.getTyp();
    if(aktHodnota.isZero()){
      cout << filename << lexik->lineno() << ": division by zero" <<endl;
      aktHodnota=ValHolder(ETYP);
    }
    else {
      aktHodnota = leftVal / aktHodnota;
      if(aHT!=ETYP && leftVal.getTyp() != ETYP && aktHodnota.getTyp()==ETYP){
        cout << filename << lexik->lineno() << ": unable to divide '";
        cout << TypesNames[aHT]<<"' value with '";
        cout << TypesNames[leftVal.getTyp()]<<"' value"<<endl;
      }
    }
    aktHodnota = t1(zachytne
	+Symbols(PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA), aktHodnota);
  }
  else if(sym==KRAT){
    expect(KRAT,zachytne);
    aktHodnota = f(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|KONEC|STREDNIK|PZAVORKA));
    aHT=aktHodnota.getTyp();
    aktHodnota = leftVal * aktHodnota;
    if(aHT != ETYP && leftVal.getTyp() != ETYP && aktHodnota.getTyp()==ETYP){
      cout << filename << lexik->lineno() << ": unable to multiply '";
      cout << TypesNames[aHT]<<"' value with '";
      cout << TypesNames[leftVal.getTyp()]<<"' value"<<endl;
    }
    aktHodnota = t1(zachytne
	+Symbols(PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA), aktHodnota);
  }
  else if(sym==DIV){
    expect(DIV,zachytne);
    aktHodnota = f(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|KONEC|STREDNIK|PZAVORKA));
    aHT=aktHodnota.getTyp();
    if(aktHodnota.isZero()){
      cout << filename << lexik->lineno() << ": division by zero" <<endl;
      aktHodnota=ValHolder(ETYP);
    }
    else {
      aktHodnota = leftVal.div(aktHodnota);
      if(aHT != ETYP && leftVal.getTyp() != ETYP && aktHodnota.getTyp()==ETYP){
        cout << filename << lexik->lineno(); 
        cout << ": unable to integer divide '";
        cout << TypesNames[aHT]<<"' value with '";
        cout << TypesNames[leftVal.getTyp()]<<"' value"<<endl;
      }
    }
    aktHodnota = t1(zachytne
	+Symbols(PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA), aktHodnota);
  }
  else if(sym==MOD){
    expect(MOD,zachytne);
    aktHodnota = f(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA));
    aHT=aktHodnota.getTyp();
    if(aktHodnota.isZero()){
      cout << filename << lexik->lineno() << ": division by zero" <<endl;
      aktHodnota=ValHolder(ETYP);
    }
    else {
      aktHodnota = leftVal % aktHodnota;
      if(aHT != ETYP && leftVal.getTyp() != ETYP && aktHodnota.getTyp()==ETYP){
        cout << filename << lexik->lineno(); 
        cout << ": unable to integer divide '";
        cout << TypesNames[aHT]<<"' value with '";
        cout << TypesNames[leftVal.getTyp()]<<"' value"<<endl;
      }
    }
    aktHodnota = t1(zachytne
	+Symbols(PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA), aktHodnota);
  }
  return aktHodnota;
}
//F-> -F1 | +F1 | F1
ValHolder Syntakt::f(Symbols zachytne){
  check(Symbols(LZAVORKA|PLUS|MINUS|CISLO|STRING|REAL|IDINT|IDREAL|IDSTR),
		zachytne);
  ValHolder aktHodnota = symVal; 
  if(sym==PLUS){
    expect(PLUS,zachytne);
    aktHodnota = f1(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|KONEC|CARKA|STREDNIK|PZAVORKA));
    if(aktHodnota.getTyp()!=ETYP){
      aktHodnota = +aktHodnota;
      if(aktHodnota.getTyp()==ETYP){
        cout << filename << lexik->lineno(); 
        cout << ": unable to apply unary plus to '";
        cout << TypesNames[aktHodnota.getTyp()]<<"' value"<<endl;
      }
    }
  }
  else if(sym==MINUS){
    expect(MINUS,zachytne);
    aktHodnota = f1(zachytne
      +Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|KONEC|STREDNIK|PZAVORKA));
    if(aktHodnota.getTyp()!=ETYP){
      aktHodnota = -aktHodnota;
      if(aktHodnota.getTyp()==ETYP){
        cout << filename << lexik->lineno() << ": unable to negate '";
        cout << TypesNames[aktHodnota.getTyp()]<<"' value"<<endl;
      }
    }
  
  }
  else if(sym == LZAVORKA || sym == PLUS || sym == MINUS || sym == CISLO
      || sym == STRING || sym == REAL || sym == IDINT || sym == IDREAL
      || sym == IDSTR){
    aktHodnota = f1(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|STREDNIK|KONEC|PZAVORKA));
  }
  return aktHodnota;
}
//F1 -> (E) | NUM | ID
ValHolder Syntakt::f1(Symbols zachytne){
  check(Symbols(LZAVORKA|CISLO|STRING|REAL|IDINT|IDREAL|IDSTR)
		,zachytne);
  ValHolder aktHodnota; 
  if(sym == LZAVORKA){
    expect(LZAVORKA,zachytne);
    aktHodnota = e(zachytne
	+Symbols(CARKA|STREDNIK|PZAVORKA|KONEC));
    expect(PZAVORKA,zachytne);
  }
  else if(sym == STRING || sym == REAL || sym == CISLO){
    aktHodnota = num(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|KONEC|CARKA|STREDNIK|PZAVORKA));
  }
  else if(sym == IDINT || sym == IDREAL || sym == IDSTR){
    ValHolder tabHodnota;
    aktHodnota = id(zachytne
	+Symbols(KRAT|DELENO|DIV|MOD|PLUS|MINUS|CARKA|KONEC|STREDNIK|PZAVORKA));
    tabHodnota = table.getVal(aktHodnota.getName());
    if(!tabHodnota.isDef()){
      cout << filename << lexik->lineno() <<": Variable '";
      cout<<aktHodnota.getName()<<"' is not initialized"<<endl;
      aktHodnota=ValHolder(ETYP);
    }
    else {
      aktHodnota=tabHodnota;
    }
  }
  return aktHodnota;
}
//ID->idint|idstr|idreal
ValHolder Syntakt::id(Symbols zachytne){
  check(Symbols(IDINT|IDREAL|IDSTR),zachytne);
  ValHolder aktHodnota = symVal; 
  if(sym==IDINT){
    expect(IDINT,zachytne);
  }
  else if(sym==IDSTR){
    expect(IDSTR,zachytne);
  }
  else if(sym==IDREAL){
    expect(IDREAL,zachytne);
  }
  if(!table.exist(aktHodnota.getName())){
    table.addVar(aktHodnota);
  }
  
  return aktHodnota;
}
//NUM->cislo|string|real
ValHolder Syntakt::num(Symbols zachytne){
  check(Symbols(CISLO|REAL|STRING),zachytne);
  ValHolder aktHodnota = symVal; 
  if(sym==CISLO){
    expect(CISLO,zachytne);
  }
  else if(sym==STRING){
    expect(STRING,zachytne);
  }
  else if(sym==REAL){
    expect(REAL,zachytne);
  }
  return aktHodnota;
}
void Syntakt::analyzuj(){
  a();
}
