/*
 * Autor: Martin Kot
 * Nazev: Prekladac
 * Studijni cislo: KOT119
 */

enum ValuesTypes{
  ITYP,
  RTYP,
  STYP,
  ETYP
};
#define MAX_RET 1024 

static const char* TypesNames[] = {
  "integer","real","string","error type"
};

union Hodnota{
  int intValue;
  double realValue;
  char * strValue;
  Hodnota(){}
  Hodnota(char *s){
    strValue=s;
  }
  Hodnota(int i){
    intValue=i;
  }
  Hodnota(double f){
    realValue=f;
  }
};

class ValHolder{
private:
  int typ;
  Hodnota val;
  char * name;
  int defined;
public:
  ValHolder(){
    typ=ETYP;
    name=NULL;
    defined=FALSE;
  } 
  ValHolder(int t,Hodnota h){
    typ=t;
    val=h;
    name=NULL;
    defined=FALSE;
  }
  ValHolder(int t,int h){
    if(t==ITYP){
      val=Hodnota(h);
      typ=t;
    } 
    else {
      cerr << "Chyba programu" << endl;
      exit(0);
    }
    name=NULL;
    defined=FALSE;
  }
  ValHolder(int t,double h){
    if(t==RTYP){
      val=Hodnota(h);
      typ=t;
    } 
    else {
      cerr << "Chyba programu" << endl;
      exit(0);
    }
    name=NULL;
    defined=FALSE;
  }
  ValHolder(int t,char *h){
    if(t==STYP){
      val=Hodnota(h);
      typ=t;
    } 
    else {
      cerr << "Chyba programu" << endl;
      exit(0);
    }
    name=NULL;
    defined=FALSE;
  }
  ValHolder(int t){
    typ=t;
    name=NULL;
    defined=FALSE;
  }
  int getTyp(){ 
    return typ;
  }
  void setTyp(int i){ 
    typ=i;
  }
  Hodnota getVal(){
    return val;
  }
  void setVal(int v){
    val.intValue=v;
  }
  void setVal(double v){
    val.realValue=v;
  }
  void setVal(char *v){
    val.strValue=v;
  }
  void setVal(ValHolder v){
    val=v.getVal();
  }
  void setName(char *n){
    name=n;
  }
  char *getName(){
    return name;
  }
  void setDef(){
    defined=TRUE;
  }
  void setUndef(){
    defined=FALSE;
  }
  int isDef(){
    return defined;
  }
  int isZero(){
    if(typ==ITYP) {
      if(val.intValue == 0) {
        return TRUE;
      }
    }
    if(typ==RTYP) {
      if(val.realValue == 0) {
        return TRUE;
      }
    }
    return FALSE;
  }  
  ValHolder operator+();
  ValHolder operator-();
  ValHolder operator+(ValHolder right);
  ValHolder operator-(ValHolder right);
  ValHolder operator*(ValHolder right);
  ValHolder operator/(ValHolder right);
  ValHolder operator%(ValHolder right);
  ValHolder div(ValHolder right);
};

ostream& operator<<(ostream&,ValHolder&);
istream& operator>>(istream&,ValHolder&);
